#include "utils.PRO2"
#include "Llista.hpp"
#include "LlistaIOint.hpp"

int suma_llista_int(Llista<int>& l)
/* Pre: cert */
{
  int s=0;
  l.primer();
  while (!l.es_final()){
    s+=l.actual();
    l.seguent();
  }
  return s;
}
/* Post: El resultat és la suma dels elements de L */


bool pert_llista_int(Llista<int>& l, int x)
/* Pre: cert */
{
  bool b = false;
  l.primer();
  while (!l.es_final() and not b){
    if (l.actual() == x) b= true;
    else l.seguent();
  }
  return b;
}
/* Post: El resultat indica si x hi és o no a l */


void suma_llista_k(Llista<int>& l, int k)
/* Pre: l=L */
{
  l.primer();
  while (!l.es_final()){
    l.modificar_actual(l.actual()+k);
    l.seguent();    
  }
}
/* Post: El valor de cada element d'l és el valor corresponent a L més k */ 


int main(){

  Llista<int> l;
  cout << "Entra llista enters (acabada per 0): " << endl;
  llegir_llista_int(l,0);
  cout << "Suma: " <<  suma_llista_int(l) << endl;
  int x;
  cout << "Número a cercar: "; 
  cin >> x;
  if (pert_llista_int(l,x)) cout << "Hi és" << endl;
  else cout << "No hi és" << endl;
  cout << "Número a afegir: "; 
  cin >> x;
  suma_llista_k(l,x);
  escriure_llista_int(l);
  l.primer();
  l.eliminar();
  escriure_llista_int(l);
  l.ultim();
  l.eliminar();
  escriure_llista_int(l);
  if (l.mida()!=0) l.anterior();
  if (!l.es_principi()) l.anterior();
  if (!l.es_final()) l.eliminar();
  escriure_llista_int(l);
  Llista<int> l1=l;
  escriure_llista_int(l1);
}
